{% extends 'base.html' %}

{% block modals %}
    <!-- New Corpus Modal -->
    <div class="modal fade" id="new-corpus-modal" tabindex="-1" role="dialog" aria-labelledby="new-corpus-modal-label" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <form id="new-corpus-form" method="post">
                    {% csrf_token %}
                    <div class="modal-header">
                        <h5 class="modal-title" id="new-corpus-modal-label">New Corpus</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <div id="new-corpus-name-required-msg" class="alert alert-danger d-none">Please provide a name for this corpus.</div>
                        <div class="form-group">
                            <label for="new-corpus-name-box">Name</label>
                            <input type="text" class="form-control" id="new-corpus-name-box" name="new-corpus-name" />
                        </div>
                        <div class="form-group">
                            <label for="new-corpus-desc-box">Description</label>
                            <input type="text" class="form-control" id="new-corpus-desc-box" name="new-corpus-desc" />
                        </div>
                        <div class="form-check">
                            <input class="form-check-input" type="checkbox" id="new-corpus-open-checkbox" name="new-corpus-open">
                            <label class="form-check-label" for="new-corpus-open-checkbox">
                                Open access?
                            </label>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                        <button type="submit" class="btn btn-primary">Create</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
{% endblock %}

{% block main %}
        <div class="row">
            <div class="col-12">
                <div class="card mb-3">
                    <div class="card-header">
                        <div class="d-flex w-100 justify-content-between text-nowrap align-items-center">
                            <h4>Available Corpora</h4>
                            <div class="form-inline">
                                    <input type="text" class="form-control" id="search-box" placeholder="Search" />
                                    <select id="page-selector" class="form-control btn-primary ml-2"></select>
                            </div>
                        </div>
                    </div>
                    <div class="card-body p-0">
                        <div class="row">
                            <div class="col-sm-12">
                                <table class="table">
                                    <thead class="thead-dark">
                                        <th scope="col"><a href="#" id="corpus-sort-link"><h5>Corpus</h5></a></th>
                                        <th scope="col"><h5>Description</h5></th>
                                        <th scope="col"><h5>Open Access?</h5></th>
                                    </thead>
                                    <tbody id="corpus-table">
                                        <tr>
                                            <td colspan="2">
                                                <div class="alert alert-info">
                                                    Loading corpora...
                                                </div>
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                        </div>
                        {% if response.scholar.is_admin %}
                        <div class="row px-4">
                            <div class="col-sm-12">
                                <iframe id="job-iframe" src="/jobs/" width="100%" frameBorder="0"></iframe>
                            </div>
                        </div>
                        {% endif %}
                    </div>
                    {% if response.scholar.is_admin %}
                    <div class="card-footer">
                        <button type="button" class="btn btn-primary" id="corpus-new-button">New Corpus</button>
                        <a class="btn btn-secondary" href="/scholars">Manage Scholars</a>
                        <a class="btn btn-secondary" href="/exports">Export/Import Corpus</a>
                    </div>
                    {% endif %}
                </div>
            </div>
        </div>
{% endblock %}

{% block js %}

    <script type="application/javascript">
        let corpus_search = {
            q: '*',
            page: 1,
            'page-size': 50,
            's_name.raw': 'asc'
        };

        $(document).ready(function() {
            load_corpora();

            $('#corpus-new-button').click(function() {
                $('#new-corpus-modal').modal();
            });

            $("#search-box").keypress(function(e){
                let key = e.which;
                if (key === 13) {
                    let query = $("#search-box").val();
                    if (query) {
                        corpus_search.q = query + '*';
                    } else {
                        corpus_search.q = '*';
                    }
                    corpus_search.page = 1;
                    load_corpora();
                }
            });

            $('#corpus-sort-link').click(function() {
                if (corpus_search['s_name.raw'] === 'asc') corpus_search['s_name.raw'] = 'desc';
                else corpus_search['s_name.raw'] = 'asc';
                corpus_search.page = 1;

                load_corpora();
            });

            $('#page-selector').change(function() {
                corpus_search.page = parseInt($('#page-selector').val());
                load_corpora();
            });
        });

        function load_corpora() {
            corpora.get_corpora(corpus_search, build_corpora);
        }

        function build_corpora(corpora_data) {
            let corpus_table = $("#corpus-table");
            if (corpora_data.meta.total > 0) {
                let page_selector = $('#page-selector');
                page_selector.html('');
                for (let p = 0; p < corpora_data.meta.num_pages; p++) {
                    page_selector.append(`<option value="${p + 1}" ${p + 1 === corpus_search.page ? 'selected': ''}>Page ${p + 1}</option>`);
                }

                corpus_table.html('');
                corpora_data.records.forEach(corpus => {
                    corpus_table.append(`
                        <tr>
                            <td>
                                <a href="/corpus/${corpus.id}/">${corpus.name}</a>
                            </td>
                            <td>
                                ${corpus.description}
                            </td>
                            <td>
                                ${corpus.open_access ? 'Yes' : 'No'}
                            </td>
                        </tr>
                    `);
                });
            } else {
                corpus_table.html(`
                    <tr>
                        <td colspan="3">
                            <div class="alert alert-info">
                                There are no open access corpora available to view at this time. If you are authorized to access certain corpora, please <a href="/scholar">log in</a>.
                            </div>
                        </td>
                    </tr>
                `);
            }

            hide_loading_overlay();
        }

        // THIS GETS CALLED BY JOB WIDGET IN IFRAME
        function resize_job_widget() {
            let job_widget = document.getElementById("job-iframe");
            job_widget.style.height = job_widget.contentWindow.document.body.scrollHeight + 'px';
        }
    </script>

{% endblock %}